//
//  Created by Ivano Bilenchi on 04/04/18.
//  Copyright © 2018-2020 SisInf Lab. All rights reserved.
//

#import <Foundation/Foundation.h>

/**
 * Represents the type of an individual w.r.t. semantic matchmaking tasks.
 * In this context, an individual can be either a resource, a request or both.
 */
typedef NS_OPTIONS(NSUInteger, TMEIndividualType) {
    
    /// Neither a resource nor a request.
    TMEIndividualTypeNone         = 0,
    
    /// Resource.
    TMEIndividualTypeResource     = 1 << 0,
    
    /// Request.
    TMEIndividualTypeRequest      = 1 << 1,
    
    /// Both resource and request at the same time.
    TMEIndividualTypeAny = TMEIndividualTypeResource | TMEIndividualTypeRequest
};
