//
//  Created by Ivano Bilenchi on 07/02/18.
//  Copyright © 2018-2020 SisInf Lab. All rights reserved.
//

#import <Foundation/Foundation.h>

@class TMESemanticDescription;
@protocol OWLObjectProperty;

NS_ASSUME_NONNULL_BEGIN

/**
 * Models value restrictions.
 *
 * @see `TMESemanticDescription`
 */
@interface TMEUniversalRole : NSObject <NSCopying>

/// Property of this value restriction.
@property (nonatomic, copy, readonly) id<OWLObjectProperty> property;

/// Filler of this value restriction.
@property (nonatomic, copy, readonly) TMESemanticDescription *filler;

/// :nodoc:
- (instancetype)init UNAVAILABLE_ATTRIBUTE;

@end

NS_ASSUME_NONNULL_END
